"use strict";
/**
 * @athenna/core
 *
 * (c) João Lenon <lenon@athenna.io>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ControllerProvider = void 0;
const utils_1 = require("@secjs/utils");
const ioc_1 = require("@athenna/ioc");
const getAppFiles_1 = require("../Utils/getAppFiles");
class ControllerProvider extends ioc_1.ServiceProvider {
    /**
     * Bootstrap any application services.
     *
     * @return void
     */
    async boot() {
        let controllers = getAppFiles_1.getAppFiles(utils_1.Path.app('Http/Controllers'));
        controllers = await Promise.all(controllers.map(File => Promise.resolve().then(() => __importStar(require(File.path)))));
        controllers.forEach(Module => {
            const Controller = utils_1.resolveModule(Module);
            this.container.bind(`App/Controllers/${Controller.name}`, Controller);
        });
    }
}
exports.ControllerProvider = ControllerProvider;
